# This file was generated by the `rspec --init` command. Conventionally, all
# specs live under a `spec` directory, which RSpec adds to the `$LOAD_PATH`.
# Require this file using `require "spec_helper"` to ensure that it is only
# loaded once.
#
# See http://rubydoc.info/gems/rspec-core/RSpec/Core/Configuration
RSpec.configure do |config|
  config.treat_symbols_as_metadata_keys_with_true_values = true
  config.run_all_when_everything_filtered = true
  config.filter_run :focus

  # Run specs in random order to surface order dependencies. If you find an
  # order dependency and want to debug it, you can fix the order by providing
  # the seed, which is printed after each run.
  #     --seed 1234
  config.order = 'random'
end

require 'ascii_paint'

OUTPUT_FILENAME = 'painted.png'

module Helpers
  def self.cd_work_directory
    create_work_directory
    Dir.chdir(Helpers.work_directory)
  end

  def self.rm_rf_work_directory
    Dir.chdir(work_directory.parent)
    FileUtils.rm_rf(Helpers.work_directory)
  end

  def self.create_work_directory
    FileUtils.mkdir_p(work_directory)
  end

  def self.work_directory
    AsciiPaint.root.join('tmp', 'spec')
  end

  def self.fixtures_directory
    AsciiPaint.root.join('spec', 'fixtures')
  end

  # TODO: split into separate helper
  def self.each_block_character_path
    return to_enum(:each_block_character_path) unless block_given?
    block_characters_dir = AsciiPaint.root.join('data', 'block_characters')
    block_characters_dir.each_child(false) do |path|
      full_path = block_characters_dir.join(path)
      yield full_path
    end
  end
end
